// sdimenuView.cpp : implementation of the CSdimenuView class
//

#include "stdafx.h"
#include "sdimenu.h"

#include "sdimenuDoc.h"
#include "sdimenuView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define ID_MENU_RED		5001
#define ID_MENU_GREEN	5002
#define ID_MENU_BLUE	5003
#define ID_MENU_YELLOW	5004

/////////////////////////////////////////////////////////////////////////////
// CSdimenuView

IMPLEMENT_DYNCREATE(CSdimenuView, CView)

BEGIN_MESSAGE_MAP(CSdimenuView, CView)
	//{{AFX_MSG_MAP(CSdimenuView)
	ON_COMMAND(ID_RADIOMENU_RADIO1, OnRadiomenuRadio1)
	ON_COMMAND(ID_RADIOMENU_RADIO2, OnRadiomenuRadio2)
	ON_COMMAND(ID_RADIOMENU_RADIO3, OnRadiomenuRadio3)
	ON_UPDATE_COMMAND_UI(ID_RADIOMENU_RADIO1, OnUpdateRadiomenuRadio1)
	ON_UPDATE_COMMAND_UI(ID_RADIOMENU_RADIO2, OnUpdateRadiomenuRadio2)
	ON_UPDATE_COMMAND_UI(ID_RADIOMENU_RADIO3, OnUpdateRadiomenuRadio3)
	ON_WM_RBUTTONDOWN()
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_MYPOPUPMENU_EAST, OnMypopupmenuEast)
	ON_COMMAND(ID_MYPOPUPMENU_NORTH, OnMypopupmenuNorth)
	ON_COMMAND(ID_MYPOPUPMENU_SOUTH, OnMypopupmenuSouth)
	ON_COMMAND(ID_MYPOPUPMENU_WEST, OnMypopupmenuWest)
	ON_UPDATE_COMMAND_UI(ID_MYPOPUPMENU_NORTH, OnUpdateMypopupmenuNorth)
	ON_UPDATE_COMMAND_UI(ID_MYPOPUPMENU_EAST, OnUpdateMypopupmenuEast)
	ON_UPDATE_COMMAND_UI(ID_MYPOPUPMENU_SOUTH, OnUpdateMypopupmenuSouth)
	ON_UPDATE_COMMAND_UI(ID_MYPOPUPMENU_WEST, OnUpdateMypopupmenuWest)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
	ON_COMMAND(ID_MENU_RED,OnRed)
	ON_COMMAND(ID_MENU_GREEN,OnGreen)
	ON_COMMAND(ID_MENU_YELLOW,OnYellow)
	ON_COMMAND(ID_MENU_BLUE,OnBlue)
	ON_UPDATE_COMMAND_UI(ID_MENU_YELLOW,OnUpdateYellow)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSdimenuView construction/destruction

CSdimenuView::CSdimenuView()
{
	nLastSelectedItem=ID_RADIOMENU_RADIO1;
	m_refRGB = RGB(255,240,220);
}

CSdimenuView::~CSdimenuView()
{
}

BOOL CSdimenuView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CSdimenuView drawing

void CSdimenuView::OnDraw(CDC* pDC)
{
	CSdimenuDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// Color the window depending on the chose menu option
	
	CRect rcClient;
	GetClientRect(&rcClient);
	pDC->FillSolidRect(rcClient.left,rcClient.top,
						rcClient.right,rcClient.bottom,
						m_refRGB);
}

/////////////////////////////////////////////////////////////////////////////
// CSdimenuView printing

BOOL CSdimenuView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CSdimenuView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CSdimenuView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CSdimenuView diagnostics

#ifdef _DEBUG
void CSdimenuView::AssertValid() const
{
	CView::AssertValid();
}

void CSdimenuView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CSdimenuDoc* CSdimenuView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSdimenuDoc)));
	return (CSdimenuDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSdimenuView message handlers

void CSdimenuView::OnRadiomenuRadio1() 
{
	nLastSelectedItem = ID_RADIOMENU_RADIO1;	
}

void CSdimenuView::OnRadiomenuRadio2() 
{
	nLastSelectedItem = ID_RADIOMENU_RADIO2;	
}

void CSdimenuView::OnRadiomenuRadio3() 
{
	nLastSelectedItem = ID_RADIOMENU_RADIO3;	
}

void CSdimenuView::OnUpdateRadiomenuRadio1(CCmdUI* pCmdUI) 
{
	if (pCmdUI->m_pMenu)
		pCmdUI->m_pMenu->CheckMenuRadioItem(
			ID_RADIOMENU_RADIO1,ID_RADIOMENU_RADIO3,
			nLastSelectedItem,MF_BYCOMMAND);
}

void CSdimenuView::OnUpdateRadiomenuRadio2(CCmdUI* pCmdUI) 
{
	if (pCmdUI->m_pMenu)
		pCmdUI->m_pMenu->CheckMenuRadioItem(
			ID_RADIOMENU_RADIO1,ID_RADIOMENU_RADIO3,
			nLastSelectedItem,MF_BYCOMMAND);
}

void CSdimenuView::OnUpdateRadiomenuRadio3(CCmdUI* pCmdUI) 
{
	if (pCmdUI->m_pMenu)
		pCmdUI->m_pMenu->CheckMenuRadioItem(
			ID_RADIOMENU_RADIO1,ID_RADIOMENU_RADIO3,
			nLastSelectedItem,MF_BYCOMMAND);
}

void CSdimenuView::OnRButtonDown(UINT nFlags, CPoint point) 
{

	CView::OnRButtonDown(nFlags, point);
}


void CSdimenuView::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	// ** Declare a CMenu object
	CMenu menuPopup;

	// ** Create the popup menu resource
	if (menuPopup.CreatePopupMenu())
	{
		// ** Add simple menu items
		menuPopup.AppendMenu(MF_STRING,ID_MENU_RED,"&Red");

		//** Insert an item at the top of the menu
		menuPopup.InsertMenu(0, MF_BYPOSITION | MF_STRING,
							ID_MENU_GREEN,"&Green");

		// ** Add a seperator item
		menuPopup.AppendMenu(MF_SEPARATOR);

		// ** Add a checked item
		menuPopup.AppendMenu(MF_STRING | MF_CHECKED,
							ID_MENU_BLUE,"&Blue");

		// ** MF_MENUBARBREAK 
		menuPopup.AppendMenu(MF_STRING | MF_MENUBARBREAK ,ID_MENU_YELLOW,"&Yellow");

//		menuPopup.ModifyMenu(ID_MENU_YELLOW,
//			MF_BYCOMMAND | MF_CHECKED | MF_STRING | MF_MENUBARBREAK, 
//									ID_MENU_YELLOW,"&Yellow");

//		menuPopup.CheckMenuItem(ID_MENU_YELLOW,MF_BYCOMMAND | MF_CHECKED);

		menuPopup.TrackPopupMenu(TPM_LEFTALIGN,
										point.x,point.y,this);

	}
}

	// ** Initialize the object with the context menu resource
//	menuPopup.LoadMenu(IDR_MYCONTEXT);

	// ** Display and start tracking the new menu
//	menuPopup.GetSubMenu(0)->TrackPopupMenu(TPM_LEFTALIGN,
//										point.x,point.y,this);
//}

BOOL g_bEnableYellow = FALSE;

void CSdimenuView::OnYellow()
{
	AfxMessageBox("Yellow");
	m_refRGB = RGB(255,255,0);
	g_bEnableYellow = FALSE;
	Invalidate();
}

void CSdimenuView::OnUpdateYellow(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(g_bEnableYellow);
}

void CSdimenuView::OnRed()
{
	AfxMessageBox("Red");
	m_refRGB = RGB(255,0,0);
	g_bEnableYellow = TRUE;
	Invalidate();
}

void CSdimenuView::OnGreen()
{
	AfxMessageBox("Green");
	m_refRGB = RGB(0,255,0);
	g_bEnableYellow = TRUE;
	Invalidate();
}

void CSdimenuView::OnBlue()
{
	AfxMessageBox("Blue");
	m_refRGB = RGB(0,0,255);
	g_bEnableYellow = TRUE;
	Invalidate();
}


void CSdimenuView::OnMypopupmenuEast() 
{
	AfxMessageBox("East");	
}

void CSdimenuView::OnMypopupmenuNorth() 
{
	AfxMessageBox("North");	
}

void CSdimenuView::OnUpdateMypopupmenuNorth(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(TRUE);
}


void CSdimenuView::OnMypopupmenuSouth() 
{
	AfxMessageBox("South");	
}

void CSdimenuView::OnMypopupmenuWest() 
{
	AfxMessageBox("West");	
}


void CSdimenuView::OnUpdateMypopupmenuEast(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(TRUE);
}

void CSdimenuView::OnUpdateMypopupmenuSouth(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(TRUE);
}

void CSdimenuView::OnUpdateMypopupmenuWest(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(TRUE);
}
