// BezierDrawView.cpp : implementation of the CBezierDrawView class
//

#include "stdafx.h"
#include "BezierDraw.h"

#include "BezierDrawDoc.h"
#include "BezierDrawView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBezierDrawView

IMPLEMENT_DYNCREATE(CBezierDrawView, CView)

BEGIN_MESSAGE_MAP(CBezierDrawView, CView)
	//{{AFX_MSG_MAP(CBezierDrawView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBezierDrawView construction/destruction

CBezierDrawView::CBezierDrawView()
{
	// TODO: add construction code here

}

CBezierDrawView::~CBezierDrawView()
{
}

BOOL CBezierDrawView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CBezierDrawView drawing

void CBezierDrawView::OnDraw(CDC* pDC)
{
	CBezierDrawDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	CRect rcClient;
	GetClientRect(&rcClient);
	CPen penRed(PS_SOLID,2,RGB(255,0,0)),*pOldPen;

	pOldPen = pDC->SelectObject(&penRed);

	// Create an array to hold the points
	CPoint ptBezierAr[4];						
	CPen penBlue(PS_SOLID,3,RGB(0,0,255));		

	pDC->SelectObject(&penBlue);
	for(int i=0; i < 4 ;i++)
	{							
		// Setup an array of random points
		ptBezierAr[i] =
			CPoint(rand()%rcClient.Width(),	
				   rand()%rcClient.Height());

		// Draw a label
		CString strPointLabel;
		strPointLabel.Format("%d.",i+1);
		pDC->TextOut(ptBezierAr[i].x,
					 ptBezierAr[i].y,
					 strPointLabel);

		// Draw the co-ordinates as blue dots
		CRect rcDot(ptBezierAr[i],ptBezierAr[i]);
		rcDot.InflateRect(2,2);	
		pDC->Ellipse(rcDot);
	}									

	// Draw a red Bezier curve
	pDC->SelectObject(&penRed);	
	pDC->PolyBezier(ptBezierAr,4);
	
	pDC->SelectObject(pOldPen);
}

/////////////////////////////////////////////////////////////////////////////
// CBezierDrawView printing

BOOL CBezierDrawView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CBezierDrawView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CBezierDrawView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CBezierDrawView diagnostics

#ifdef _DEBUG
void CBezierDrawView::AssertValid() const
{
	CView::AssertValid();
}

void CBezierDrawView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CBezierDrawDoc* CBezierDrawView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBezierDrawDoc)));
	return (CBezierDrawDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CBezierDrawView message handlers
