#include "math.h"
void CMyDrawView::OnDraw(CDC* pDC)
{
	CMyDrawDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	CPen penRed(PS_SOLID,5,RGB(255,0,0));		
	CPen *pOldPen = NULL;					

	pOldPen = pDC->SelectObject(&penRed);

	CRect rcClient;	
	GetClientRect(&rcClient);

	CBrush brBlue(RGB(0,0,255));
	CBrush *pOldBrush = NULL;

	pOldBrush = pDC->SelectObject(&brBlue);	

	for(int w=0;w<2;w++)
	{
		const int nPoints = 5;
		double nAngle = (720.0/57.295)/(double)nPoints;
		int xOffset = (w ? 1 : -1)*rcClient.Width()/4;
		pDC->SetPolyFillMode(w ? ALTERNATE : WINDING);
		CPoint ptPolyAr[nPoints];
		for(int i=0;i<nPoints;i++)	
		{	
			ptPolyAr[i].x = xOffset + 
			  (long)(sin((double)i * nAngle) * 100.0);
			ptPolyAr[i].y = 
			  (long)(cos((double)i * nAngle) * 100.0);		
			ptPolyAr[i] += rcClient.CenterPoint();	
		}
		pDC->Polygon(ptPolyAr,nPoints);
	}

	pDC->SelectObject(pOldBrush);
	pDC->SelectObject(pOldPen);
}
