// PolyDrawView.cpp : implementation of the CPolyDrawView class
//

#include "stdafx.h"
#include "PolyDraw.h"

#include "PolyDrawDoc.h"
#include "PolyDrawView.h"

// This include is required for sin & cos functions
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPolyDrawView

IMPLEMENT_DYNCREATE(CPolyDrawView, CView)

BEGIN_MESSAGE_MAP(CPolyDrawView, CView)
	//{{AFX_MSG_MAP(CPolyDrawView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPolyDrawView construction/destruction

CPolyDrawView::CPolyDrawView()
{
	// TODO: add construction code here

}

CPolyDrawView::~CPolyDrawView()
{
}

BOOL CPolyDrawView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CPolyDrawView drawing

void CPolyDrawView::OnDraw(CDC* pDC)
{
	CPolyDrawDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	CPen penRed(PS_SOLID,5,RGB(255,0,0));		
	CPen *pOldPen = NULL;					

	pOldPen = pDC->SelectObject(&penRed);

	CRect rcClient;	
	GetClientRect(&rcClient);

	CBrush brBlue(RGB(0,0,255));
	CBrush *pOldBrush = NULL;

	pOldBrush = pDC->SelectObject(&brBlue);	

	for(int w=0;w<2;w++)
	{
		const int nPoints = 5;
		double nAngle = (720.0/57.295)/(double)nPoints;
		int xOffset = (w ? 1 : -1)*rcClient.Width()/4;
		pDC->SetPolyFillMode(w ? ALTERNATE : WINDING);
		CPoint ptPolyAr[nPoints];
		for(int i=0;i<nPoints;i++)	
		{	
			ptPolyAr[i].x = xOffset + 
			  (long)(sin((double)i * nAngle) * 100.0);
			ptPolyAr[i].y = 
			  (long)(cos((double)i * nAngle) * 100.0);		
			ptPolyAr[i] += rcClient.CenterPoint();	
		}
		pDC->Polygon(ptPolyAr,nPoints);
	}
}

/////////////////////////////////////////////////////////////////////////////
// CPolyDrawView printing

BOOL CPolyDrawView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CPolyDrawView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CPolyDrawView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CPolyDrawView diagnostics

#ifdef _DEBUG
void CPolyDrawView::AssertValid() const
{
	CView::AssertValid();
}

void CPolyDrawView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CPolyDrawDoc* CPolyDrawView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CPolyDrawDoc)));
	return (CPolyDrawDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CPolyDrawView message handlers
