// ** The Font Callback function
int CALLBACK FontCallBack(ENUMLOGFONT FAR* lpelf,        
                           NEWTEXTMETRIC FAR *lpnt,  
                           int FontType,            
                           LPARAM lParam)            
{                                
   // ** Pick the DC pointer from the lParam
   CDC* pDC = (CDC*)lParam;                
   CFont fnEnum;                        
 
    // ** Create the font indirectly
    fnEnum.CreateFontIndirect(&lpelf->elfLogFont);    
    
    CFont* pOldFont = pDC->SelectObject(&fnEnum);    
    
    // ** Get the current Cursor position 
    int nYPos = pDC->GetCurrentPosition().y;        
 
    // ** Draw the font name
    pDC->TextOut(5,nYPos,CString(lpelf->elfLogFont.lfFaceName)); 
 
    //** Move down by the height of the font
    pDC->MoveTo(0,nYPos + lpelf->elfLogFont.lfHeight);    
 
    pDC->SelectObject(pOldFont);                
 
    // ** return TRUE to keep on going
    return TRUE;                        
}                                
 
 

/////////////////////////////////////////////////////////////////////////////
// CSimpTextView drawing

void CSimpTextView::OnDraw(CDC* pDC)
{
      CSimpTextDoc* pDoc = GetDocument();
      ASSERT_VALID(pDoc);
      
      // TODO: add draw code for native data here
      
       // ** Setup the enum callback calling your function
      EnumFontFamilies(pDC->GetSafeHdc(),NULL,         
              (FONTENUMPROC)FontCallBack,(LPARAM)pDC); 
}
