// Chap20P1View.cpp : implementation of the CChap20P1View class
//

#include "stdafx.h"
#include "Chap20P1.h"

#include "Chap20P1Doc.h"
#include "Chap20P1View.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChap20P1View

IMPLEMENT_DYNCREATE(CChap20P1View, CListView)

BEGIN_MESSAGE_MAP(CChap20P1View, CListView)
	//{{AFX_MSG_MAP(CChap20P1View)
	ON_NOTIFY_REFLECT(NM_CLICK, OnClick)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CListView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CListView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CListView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChap20P1View construction/destruction

CChap20P1View::CChap20P1View()
{
	// TODO: add construction code here

}

CChap20P1View::~CChap20P1View()
{
}

BOOL CChap20P1View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CListView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CChap20P1View drawing

void CChap20P1View::OnDraw(CDC* pDC)
{
	CChap20P1Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
}

void CChap20P1View::OnInitialUpdate()
{
	CListView::OnInitialUpdate();

	// TODO: You may populate your ListView with items by directly accessing
	//  its list control through a call to GetListCtrl().

	// ** Insert the columns
	GetListCtrl().InsertColumn(0,"Element Name",LVCFMT_LEFT,120);
	GetListCtrl().InsertColumn(1,"Symbol",LVCFMT_CENTER,70);
	GetListCtrl().InsertColumn(2,"Atomic Number",LVCFMT_RIGHT,130);

	// Get a pointer to the document
	CChap20P1Doc* pDoc = GetDocument();
	// make sure it is a valid document
	ASSERT_VALID(pDoc);

	// Find the head position of the string list
	POSITION pos = pDoc->GetElements().GetHeadPosition();

	// While the position is not NULL, add elements
	while(pos)
	{
		// Get the next element in the list
		CString strElement = pDoc->GetElements().GetNext(pos);

		// ** Find the name part of the string
		CString strName = 
			strElement.Left(strElement.Find(","));

		// ** Find the symbol & Number part of the string
		CString strSymbol = 
			strElement.Mid(strElement.Find(",")+1);

		// ** Find the atomic number part of the string
		CString strAtomicNumber = 
			strSymbol.Mid(strSymbol.Find(",")+1);

		// ** Cut the atomic number from the end of the symbol
		strSymbol = strSymbol.Left(strSymbol.Find(","));

		// ** Insert it into the list view at position zero
		GetListCtrl().InsertItem(0,strName);

		// ** Set the second column text to the symbol
		GetListCtrl().SetItemText(0,1,strSymbol);

		// ** Set the third column text to the symbol
		GetListCtrl().SetItemText(0,2,strAtomicNumber);

	}

	// Get the current style flags
	DWORD dwStyle = GetWindowLong(GetListCtrl().GetSafeHwnd(),
													GWL_STYLE);

	// Remove the current style flags
	dwStyle &= ~LVS_TYPEMASK;

	// ** Add the List style
	dwStyle |= LVS_REPORT;

	// Set it back into the list view
	SetWindowLong(GetListCtrl().GetSafeHwnd(),
									GWL_STYLE,dwStyle);


	// Redraw the list view
	SetRedraw(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// CChap20P1View printing

BOOL CChap20P1View::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CChap20P1View::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CChap20P1View::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CChap20P1View diagnostics

#ifdef _DEBUG
void CChap20P1View::AssertValid() const
{
	CListView::AssertValid();
}

void CChap20P1View::Dump(CDumpContext& dc) const
{
	CListView::Dump(dc);
}

CChap20P1Doc* CChap20P1View::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CChap20P1Doc)));
	return (CChap20P1Doc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CChap20P1View message handlers

void CChap20P1View::OnClick(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	
	*pResult = 0;

	// ** String to hold selected items
	CString strSelectedItems;

	// ** Initial GetNextItem() index must be zero
	int nSelected=-1;
	do
	{
		// ** Find the next selected item 
		nSelected = GetListCtrl().GetNextItem(
									nSelected,LVNI_SELECTED);

		// ** Is there a selected item
		if (nSelected != -1)
		{
			// ** Add it's text to the list
			strSelectedItems += _T(" ") + 
				GetListCtrl().GetItemText(nSelected,0);
		}
	} while(nSelected != -1);

	// ** Set the document title to the selected items
	GetDocument()->SetTitle(
						_T("Selected:") + strSelectedItems);
}
