void CListVView::OnInitialUpdate()
{
   CListView::OnInitialUpdate();

    // TODO: You may populate your ListView with items 
    //  its list control through a call to GetListCtrl()

    // ** Insert the columns and headings
    GetListCtrl().InsertColumn(0,"Element Name",
									LVCFMT_LEFT,120);
    GetListCtrl().InsertColumn(1,"Symbol",
									LVCFMT_CENTER,70);
    GetListCtrl().InsertColumn(2,"Atomic Number",
									LVCFMT_RIGHT,130);

    // Get a pointer to the document
    CListVDoc* pDoc = GetDocument();
    // make sure it is a valid document
    ASSERT_VALID(pDoc);

    // Find the head position of the string list
    POSITION pos = 
		pDoc->GetElements().GetHeadPosition();

    // While the position is not NULL, add elements
    while(pos)
    {
        // Get the next element in the list
        CString strElement = 
			pDoc->GetElements().GetNext(pos);

        // ** Find the name part of the string
        CString strName =
             strElement.Left(strElement.Find(","));

         // ** Find the symbol & Number part 
         CString strSymbol =
            strElement.Mid(strElement.Find(",")+1);

         // ** Find the atomic number part 
         CString strAtomicNumber =
            strSymbol.Mid(strSymbol.Find(",")+1);

         // ** Cut the atomic number from the end 
         strSymbol = 
            strSymbol.Left(strSymbol.Find(","));

         // ** Insert it into the list view at 0
         GetListCtrl().InsertItem(0,strName);

         // ** Set the second column text to the symbol
         GetListCtrl().SetItemText(0,1,
                                    strSymbol);

         // ** Set the third column text to the symbol
         GetListCtrl().SetItemText(0,2,
                                    strAtomicNumber);

     }

     // Get the current style flags
     DWORD dwStyle = 
         GetWindowLong(GetListCtrl().GetSafeHwnd(),
                                          GWL_STYLE);

     // Remove the current style flags
     dwStyle &= ~LVS_TYPEMASK;

     // ** Add the List style
     dwStyle |= LVS_REPORT;

     // Set it back into the list view
     SetWindowLong(GetListCtrl().GetSafeHwnd(),
         GWL_STYLE,dwStyle);

     // Redraw the list view
     SetRedraw(TRUE);
}
