void CPrintItView::OnDraw(CDC* pDC)
{
	CPrintItDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
		
	// ** Set metric mapping
	pDC->SetMapMode(MM_LOMETRIC);

	// ** Declare and create a font 2.2cm high
	CFont fnBig;
	fnBig.CreateFont(220,0,0,0,FW_HEAVY,FALSE,FALSE,0,
						ANSI_CHARSET,OUT_DEFAULT_PRECIS,
						CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,
						FF_SWISS+VARIABLE_PITCH,"Arial");

	//** Select the new font and store the original
	CFont* pOldFont = pDC->SelectObject(&fnBig);

	//** Declare a client rectangle
	CRect rcClient;
	GetClientRect(&rcClient);

	// ** Convert to logical units
	pDC->DPtoLP(&rcClient);

	// ** Set up some drawing variables
	const int nPoints = 50;
	int xm = rcClient.Width();
	int ym = rcClient.Height();
	double dAspW = xm/(double)nPoints;
	double dAspH = ym/(double)nPoints;

	// ** Select a black pen
	CPen* pOldPen = (CPen*)pDC->SelectStockObject(BLACK_PEN);

	// ** Draw the lines
	for(int i=0;i<nPoints;i++)
	{
		int xo = (int)(i * dAspW);
		int yo = (int)(i * dAspH);

		pDC->MoveTo(xo,0);
		pDC->LineTo(xm,yo);
		pDC->LineTo(xm-xo,ym);
		pDC->LineTo(0,ym-yo);
		pDC->LineTo(xo,0);
	}

	// ** Reselect the old pen
	pDC->SelectObject(pOldPen);

	// ** Draw the text on top
	pDC->SetTextAlign(TA_CENTER+TA_BASELINE);
	pDC->SetBkMode(TRANSPARENT);

	// ** Set grey text
	pDC->SetTextColor(RGB(64,64,64));
	pDC->TextOut(xm/2,ym/2,"Sample Print");

	// ** Reselect the old font
	pDC->SelectObject(pOldFont);
}