	//** Declare a client rectangle and get the client rect
	CRect rcClient;
	GetClientRect(&rcClient);

	// ** Check the device context for printing mode
	if (pDC->IsPrinting())
	{
		// ** Find the Print width : Window width ratio
		double dWidthRatio = (double)m_rcPrintRect.Width() / 
								(double)rcClient.Width();

		// ** Find the Print height : Window height ratio
		double dHeightRatio = (double)m_rcPrintRect.Height() / 
								(double)rcClient.Height();

		// ** Calculate the device's aspect ratio
		double dAspect = (double) pDC->GetDeviceCaps(ASPECTX) /
								(double)pDC->GetDeviceCaps(ASPECTY);
		
		// ** Find the new relative height
		int nHeight = (int)(rcClient.Height() * 
										dWidthRatio * dAspect );

		// ** Find the new relative width
		int nWidth = (int)(rcClient.Width() * 
								dHeightRatio * (1.0 / dAspect) );

		// ** Set the whole rectangle 
		rcClient = m_rcPrintRect;

		// ** Determine the best fit, across or down the page
		if (nHeight > nWidth)
		{
			// ** Down is best, so adjust the width
			rcClient.BottomRight().x = 
					m_rcPrintRect.TopLeft().x + nWidth; 
		}
		else
		{
			// ** Across is best, so adjust the height
			rcClient.BottomRight().y = 
					m_rcPrintRect.TopLeft().y + nHeight; 
		}
	}

	// Convert to logical units
	pDC->DPtoLP(&rcClient);
