void CPrintItView::OnPrint(CDC* pDC, CPrintInfo* pInfo) 
{
	// TODO: Add your specialized code here and/or call the base class

	// ** Create and select the font 
	CFont fnTimes;
	fnTimes.CreatePointFont(720,"Times New Roman",pDC);
	CFont* pOldFont = (CFont*)pDC->SelectObject(&fnTimes);

	// ** Create and select the brushe
	CBrush brHatch(HS_CROSS,RGB(64,64,64)); 
	CBrush* pOldBrush = (CBrush*)pDC->SelectObject(&brHatch);

	// ** Create the page text
	CString strDocText;
	strDocText.Format("Page Number %d",pInfo->m_nCurPage);
	
	pDC->SetTextAlign(TA_CENTER+TA_BASELINE);

	// ** Set up some useful point objects
	CPoint ptCenter = pInfo->m_rectDraw.CenterPoint();
	CPoint ptTopLeft = pInfo->m_rectDraw.TopLeft();
	CPoint ptBotRight = pInfo->m_rectDraw.BottomRight();

	// ** Create the points for the diamond
	CPoint ptPolyArray[4]=
		{
			CPoint(ptTopLeft.x,ptCenter.y),
			CPoint(ptCenter.x,ptTopLeft.y),
			CPoint(ptBotRight.x,ptCenter.y),
			CPoint(ptCenter.x,ptBotRight.y) 
		};

	// ** Draw the diamond
	pDC->Polygon(ptPolyArray,4);

	// ** Draw the text
	pDC->TextOut(ptCenter.x,ptCenter.y,strDocText);

	// ** Unselect the fonts
	pDC->SelectObject(pOldFont);
	pDC->SelectObject(pOldBrush);
}
