// DlgProxy.cpp : implementation file
//

#include "stdafx.h"
#include "autoclient.h"
#include "DlgProxy.h"
#include "autoclientDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAutoclientDlgAutoProxy

IMPLEMENT_DYNCREATE(CAutoclientDlgAutoProxy, CCmdTarget)

CAutoclientDlgAutoProxy::CAutoclientDlgAutoProxy()
{
	EnableAutomation();
	
	// To keep the application running as long as an automation 
	//	object is active, the constructor calls AfxOleLockApp.
	AfxOleLockApp();

	// Get access to the dialog through the application's
	//  main window pointer.  Set the proxy's internal pointer
	//  to point to the dialog, and set the dialog's back pointer to
	//  this proxy.
	ASSERT (AfxGetApp()->m_pMainWnd != NULL);
	ASSERT_VALID (AfxGetApp()->m_pMainWnd);
	ASSERT_KINDOF(CAutoclientDlg, AfxGetApp()->m_pMainWnd);
	m_pDialog = (CAutoclientDlg*) AfxGetApp()->m_pMainWnd;
	m_pDialog->m_pAutoProxy = this;
}

CAutoclientDlgAutoProxy::~CAutoclientDlgAutoProxy()
{
	// To terminate the application when all objects created with
	// 	with automation, the destructor calls AfxOleUnlockApp.
	//  Among other things, this will destroy the main dialog
	if (m_pDialog != NULL)
		m_pDialog->m_pAutoProxy = NULL;
	AfxOleUnlockApp();
}

void CAutoclientDlgAutoProxy::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTarget::OnFinalRelease();
}

BEGIN_MESSAGE_MAP(CAutoclientDlgAutoProxy, CCmdTarget)
	//{{AFX_MSG_MAP(CAutoclientDlgAutoProxy)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CAutoclientDlgAutoProxy, CCmdTarget)
	//{{AFX_DISPATCH_MAP(CAutoclientDlgAutoProxy)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_IAutoclient to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {1033AB20-D0B3-11D1-8647-004095A12AF9}
static const IID IID_IAutoclient =
{ 0x1033ab20, 0xd0b3, 0x11d1, { 0x86, 0x47, 0x0, 0x40, 0x95, 0xa1, 0x2a, 0xf9 } };

BEGIN_INTERFACE_MAP(CAutoclientDlgAutoProxy, CCmdTarget)
	INTERFACE_PART(CAutoclientDlgAutoProxy, IID_IAutoclient, Dispatch)
END_INTERFACE_MAP()

// The IMPLEMENT_OLECREATE2 macro is defined in StdAfx.h of this project
// {1033AB1E-D0B3-11D1-8647-004095A12AF9}
IMPLEMENT_OLECREATE2(CAutoclientDlgAutoProxy, "Autoclient.Application", 0x1033ab1e, 0xd0b3, 0x11d1, 0x86, 0x47, 0x0, 0x40, 0x95, 0xa1, 0x2a, 0xf9)

/////////////////////////////////////////////////////////////////////////////
// CAutoclientDlgAutoProxy message handlers
