CDrawDlg::CDrawDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDrawDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDrawDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_pIDraw = NULL;
	m_pIMainSurface = NULL;

	CoInitialize(NULL);
}

CDrawDlg::~CDrawDlg()
{
	if (m_pIMainSurface) 
	{
		m_pIDraw->SetCooperativeLevel(m_hWnd,DDSCL_NORMAL);
		m_pIDraw->RestoreDisplayMode();
		m_pIMainSurface->Release();
	}
	if (m_pIDraw) m_pIDraw->Release();
	CoUninitialize();
}

double dX[100],dY[100];

BOOL CDrawDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ** Initialize the OLE / COM library
	if (FAILED(CoInitialize(NULL))) return FALSE;
	
	// ** Create a direct draw object and interface
	HRESULT hr = CoCreateInstance(CLSID_DirectDraw,NULL,
		CLSCTX_ALL, IID_IDirectDraw2, (void**)&m_pIDraw);

	if(!FAILED(hr)) 
	{
		hr = m_pIDraw->Initialize((struct _GUID*)NULL);
		if (hr !=DD_OK) return FALSE;
	}
	
	// ** Set exclusive full screen mode
	m_pIDraw->SetCooperativeLevel(m_hWnd,
		DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN | DDSCL_ALLOWREBOOT);

	// ** Set up a surface description structure
	DDSURFACEDESC DrawSurfaceDesc;
	memset(&DrawSurfaceDesc,0,sizeof(DrawSurfaceDesc));
	DrawSurfaceDesc.dwSize = sizeof(DrawSurfaceDesc);
	DrawSurfaceDesc.dwFlags = DDSD_CAPS | DDSD_BACKBUFFERCOUNT;
	DrawSurfaceDesc.ddsCaps.dwCaps = 
		DDSCAPS_COMPLEX | DDSCAPS_FLIP | DDSCAPS_PRIMARYSURFACE;
	DrawSurfaceDesc.dwBackBufferCount = 1;

	// ** Create the primary surface
	hr = m_pIDraw->CreateSurface(&DrawSurfaceDesc,
			(IDirectDrawSurface**)&m_pIMainSurface,NULL);
	if (FAILED(hr)) return FALSE;

	// ** Find the back buffer
	DrawSurfaceDesc.ddsCaps.dwCaps = DDSCAPS_BACKBUFFER;
	hr = m_pIMainSurface->GetAttachedSurface(&DrawSurfaceDesc.
										ddsCaps,&m_pIFlipSurface);

	SetTimer(1,50,0); // ** Start the 50ms Timer

	for(int i=0;i<100;i++)
	{
		dX = dY = 200.0;
	}
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}


void CDrawDlg::OnTimer(UINT nIDEvent) 
{
	CDialog::OnTimer(nIDEvent);

	static RECT rc={0,0,0,0};		

	// ** Clear the surface quickly with a blit
	if (rc.right>0)
	{
		DDBLTFX dbltfx;
		dbltfx.dwSize=sizeof(DDBLTFX);
		dbltfx.dwFillColor=RGB(0,0,0);
		HRESULT hr = m_pIFlipSurface->Blt(&rc,NULL,&rc,DDBLT_COLORFILL,&dbltfx);

	}

	HDC hdc = NULL;

	// ** Get a device context for the surface
	if (m_pIFlipSurface->GetDC(&hdc) == DD_OK)
	{
		if (hdc)
		{
			CDC dc;
			dc.Attach(hdc);
					
			rc.right = dc.GetDeviceCaps(HORZRES);
			rc.bottom = dc.GetDeviceCaps(VERTRES);

			double mx = (double)(rc.right>>1);
			double my = (double)(rc.bottom>>1);

			CPen psCol(PS_SOLID,1,RGB(0,255,0));
			CPen* ppsOld = dc.SelectObject(&psCol);

			dX += 0.5 - (rand()%10)/10.0;
			dY += 0.5 - (rand()%10)/10.0;
			
			dc.LineTo((int)dX,(int)dY);

			dc.SelectObject(ppsOld);
			dc.Detach();
		}
		m_pIFlipSurface->ReleaseDC(hdc);
	}

	// ** Show the newly drawn surface
	m_pIMainSurface->Flip(NULL,DDFLIP_WAIT);
}
